package Langs::default::LAdmin;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(&get_lang);

use strict;

my $lang =
{(
    # --- --- Admin.pm
  # --- common
  'keyword_too_long'       => "Keyword should be <= 20 chars. Please try again!",
  'at_least_one'           => "You need to choose at least one item in the section above.",
  'save_moderators'        => "Save Moderators",
  'save_group1'            => "Save Group",
  # --- remove category
  'has_boards'             => "You cannot delete a category that contains boards.",
  'category_deleted1'      => "Category has been deleted",
  'category_deleted2'      => "Category has been deleted. You will be returned to main administration page shortly.",
  # --- save category
  'dup_cat'                => "We already have the keyword/title for this category you provided in our database.",
  'cat_created1'           => "Category Created",
  'cat_created2'           => "Category has been created and is now available for forums to be placed within it. You will be returned to main administration page shortly.",
  'category_updated1'      => "Category has been updated",
  'category_updated2'      => "Category has been updated. You will be returned to main administration page shortly.",
  'non_word_cat'           => "Category keyword cannot include nonword characters. You will be returned to main administration page shortly.",
  # --- save board
  'dup_sid'                => "We already have the keyword/title for this board you provided in our database.",
  'board_created1'         => "Board Created",
  'board_created2'         => "Board has been created. You will be returned to main administration page shortly.",
  'board_updated1'         => "Board has been updated",
  'board_updated2'         => "Board has been updated. You will be returned to main administration page shortly.",
  'non_word_board'         => "Board keyword cannot include nonword characters. You will be returned to main administration page shortly.",
  # --- expire threads
  'expire_threads3'        => "Threads Expired",
  'expire_threads4'        => "All threads you marked to expire have been purged from the database.  You will be returned to main administration page shortly.",
  # --- approve open close threads
  'close_threads3'         => "Threads Closed",
  'close_threads4'         => "All threads you marked to close have been closed. You will be returned to main administration page shortly.",
  'open_threads3'          => "Threads Open",
  'open_threads4'          => "All threads you marked to open have been reopen. You will be returned to main administration page shortly.",
  'approve_threads3'       => "Threads Approved",
  'approve_threads4'       => "All threads you marked have been approved. You will be returned to main administration page shortly.",
  # --- move copy threads
  'choose_board'           => "Please choose a destination boards you want the messages move/copy to.  You will be returned to main administration page shortly.",
  'move_threads3'          => "Threads Moved",
  'move_threads4'          => "All threads you marked have been moved out of this forum. You will be returned to main administration page shortly.",
  'copy_threads3'          => "Threads Copied",
  'copy_threads4'          => "All threads you marked have been copied to the selected forum. You will be returned to main administration page shortly.",  
  'unable_to_move'         => "Sorry.  You are not allowed to move the threads.",
  # --- save mod or group 
  'save_mod'               => "The moderators have been saved. You will be returned to main administration page shortly.",
  'save_group2'            => "The group privileges have been saved. You will be returned to main administration page shortly.",
  # --- remove table
  'drop_table1'            => "Board has been dropped",
  'drop_table2'            => "Board has been dropped. You will be returned to main administration page shortly.",
  # --- grant admin
  'save_admin1'            => "Save Administrator",
  'save_admin2'            => "The administrator have been assigned You will be returned to main administration page shortly.",
  # --- revoke admin
  'revoke_admin1'          => "Administrator's Right Revoked",
  'revoke_admin2'          => "The administrator's right has been cancelled. You will be returned to main administration page shortly.",
  # --- create user
  'account_create1'        => "Account Created",
  'account_create2'        => "A user account has been created. You will be returned to 
                               main administration page shortly.",
  # --- edit user
  'edit_user'              => "Edit User",
  'not_allow_edit'         => "I am sorry.  You are not allowed to edit this profile",
  # --- delete user
  'del_user1'              => "Delete User",
  'del_user2'              => "The user has been deleted. You will be returned to main administration page shortly.",,
  # --- admin.cgi
  'SaveGroup'              => "SaveGroup",
  'SaveCategory'           => "SaveCategory",
  'ChooseCategory'         => "ChooseCategory",
  'RemoveCategory'         => "RemoveCategory",
  'ChooseBoard'            => "ChooseBoard",
  'SaveBoard'              => "Saveboard",
  'RemoveBoard'            => "RemoveBoard",
  'GrantAdmin'             => "GrantAdmin",
  'RevokeAdmin'            => "RevokeAdmin",
  'ModifyProfile'          => "ModifyProfile",
  'ModifyPreferences'      => "ModifyPreferences",
  'DeleteUser'             => "DeleteUser",
  'ExpireThreads'          => "ExpireThreads",
  'CloseThreads'           => "CloseThreads",
  'OpenThreads'            => "OpenThreads",
  'ApproveThreads'         => "ApproveThreads",
  'MoveThreads'            => "MoveThreads",
  'PreviewGroup'           => "PreviewGroup",
  'SaveModerator'          => "SaveModerator",
  'PreviewModerator'       => "PreviewModerator",
  'am_login'               => "Administrator/Moderator Login"
)};

sub get_lang{
    return $lang;
}
